#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.2.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcsendbreak
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcsendbreak. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCSENDBREAK);
	funct(E_TCSENDBREAK);

	assertion(2, BASE);
	start
#ifdef tcsendbreak
		int		fildes;
		TYP_CHK_FUNCT_INT(tcsendbreak(fildes, 0),int);
#else
		not_implemented("tcsendbreak() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcsendbreak
		if(system((char *)0)) {
			chk_mcro(E_TCSENDBREAK, CLAUSE);
		} else {
			prep("Obtain macro tcsendbreak() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcsendbreak() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcsendbreak() as a macro");
#endif
	finis


#undef	tcsendbreak

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tcsendbreak(int,int);
		finis
	finis

	done();
}
