#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.6.5"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef chown
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for chown(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CHOWN);
	funct(E_CHOWN);

	assertion(2, BASE);
	start
#ifdef chown
		TYP_CHK_FUNCT_INT(chown("ABC", (uid_t)0, (gid_t)0), int);
#else
		not_implemented("chown() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	chown
		if(system((char *)0)) {
			chk_mcro(E_CHOWN, CLAUSE);
		} else {
			prep("Obtain macro chown() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that chown() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("chown() as a macro");
#endif
	finis


#undef	chown

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int chown(const char *, uid_t, gid_t);
		finis
	finis

	done();
}
