#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sv_env.h>

#define	CLAUSE		"5.6.2b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fstat
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fstat(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FSTAT);
	funct(E_FSTAT);

	assertion(2, BASE);
	start
#ifdef fstat
		struct	stat st_buf;
		TYP_CHK_FUNCT_INT(fstat(1, &st_buf), int);
#else
		not_implemented("fstat() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fstat
		if(system((char *)0)) {
			chk_mcro(E_FSTAT, CLAUSE);
		} else {
			prep("Obtain macro fstat() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fstat() macro provided in",
					"<sys/stat.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fstat() as a macro");
#endif
	finis


#undef	fstat

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int fstat(int, struct stat *);
		finis
	finis

	done();
}
