#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<dirent.h>
#include	<sv_env.h>

#define	CLAUSE		"5.1.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef opendir
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for opendir(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_OPENDIR);
	funct(E_OPENDIR);

	assertion(2, BASE);
	start
#ifdef opendir
		TYP_CHK_FUNCT_PTR(opendir("Path"), DIR);
#else
		not_implemented("opendir() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	opendir
		if(system((char *)0)) {
			chk_mcro(E_OPENDIR, CLAUSE);
		} else {
			prep("Obtain macro opendir() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that opendir() macro provided in",
					"<dirent.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("opendir() as a macro");
#endif
	finis


#undef	opendir

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern DIR *opendir(const char *);
		finis
	finis

	done();
}
