#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has S_ISUID set to ROOT.	*/

#define	FILENAME	"5.5.3_42"


int main(void)
{
	char	path_old[_POSIX_PATH_MAX +1], path_new[_POSIX_PATH_MAX +1];
	char	*pathm;
	pid_t	pid;

	setup(E_RENAME);
	funct(E_RENAME);

	assertion(42, BASE);
	start
		if(PCD_LINK_FILE_SYSTEM == TRUE) {
			pathm = fs_mount(MOUNT_RW, ROFS_REG_FILE);
		
			abstract("Ensure mounted file system gets unmounted.");
			start
				break_on(ERROR);
				preparation("Establish paths for linking.");
				start
					Zstrcpy(path_new, pathm);
					Zstrcat(path_new, "/");
					Zstrcat(path_new, FILENAME);
			
					Zstrcpy(path_old, temp_path());
					Zstrcat(path_old, "exdev_ck");
					Zclose(Zcreat(path_old, PROT_ALL));
				finis
			
				testing("Appropriate privilege process renaming a file");
				testing("onto another file system.");
				testing("Path for new is \"%s\".", path_new);
				start
					Zrename(path_old, path_new);

					Zrename(path_new, path_old); 		/* Reset */
				finis

				FORK
					prep("Set effective user ID to real user ID.");
					start
						Zsetuid(getuid());
					finis

					testing("Ordinary user process renaming a file");
					testing("onto another file system.");
					testing("Path for new is \"%s\".", path_new);
					start
						Zrename(path_old, path_new);

						Zunlink(path_new); 			/* Cleanup */
					finis
				KROF
			finis
			
			(void) fs_umount(ROFS_REG_FILE);
		}
		else
			not_implemented("{PCD_LINK_FILE_SYSTEM} of TRUE");
	finis
	
	done();
}
