#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zutime.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	Module has S_ISUID mode set to ROOT. */

#define	DIRNAME		"5.6.6_acc.d"
#define	FILENAME	"5.6.6_acc"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], path2[_POSIX_PATH_MAX +1];

	setup(E_UTIME);
	funct(E_UTIME);

	assertion(18, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path2, temp_path());
			Zstrcat(path2, DIRNAME);
			sprintf(path, "%s/%s", path2, FILENAME);
		finis

		prep("Establish path to a directory such that write access");
		prep("exists on path and search access exists on prefix of path.");
		start
			Zmkdir(path2, PROT_ALL);
			Zclose(Zcreat(path, PROT_ALL));
									/* Search access on path prefix */
			Zchmod(path2, S_IXUSR);
									/* Write access on path */
			Zchmod(path, S_IWUSR);
		finis
			
		testing("For owner of file, utime() is successful.");
		start
			expecting(SUCCESS);
			Zutime(path, (struct utimbuf *) 0);
		finis

		cleanup("Remove test files.");
		start
			Zchmod(path2, PROT_ALL);
			Zunlink(path);
			Zrmdir(path2);
		finis
	finis

	done();
}
