#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define FILENAME "6.4.2_30"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	int 	fd;

	setup(E_WRITE);
	funct(E_WRITE);

	exit_on(ERROR);

	assertion(30, EXTENDED);
	assertion(31, EXTENDED);
	assertion(32, EXTENDED);
	assertion(33, EXTENDED);

	assertion(34, BASE);
	start
		time_t	s_time;

		break_on(ERROR);
		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			fd = Zopen(path, O_WRONLY | O_CREAT | O_TRUNC, PROT_ALL);
		finis

		testing("A call to write() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the file.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			expecting(1);
			Zwrite(fd, "A", 1);
			trf_ck(CHK_CTIME, TRUE, s_time, fd, NO_PATH);
			trf_ck(CHK_MTIME, TRUE, s_time, fd, NO_PATH);
		finis
	finis

	done();
}
