#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef acos
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for acos(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ACOS);
	funct(E_ACOS);

	assertion(2, BASE);
	start
#ifdef acos
		double	value;
		TYP_CHK_ENTITY(acos(value),double);
#else
		not_implemented("acos() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	acos
		if(system((char *)0)) {
			chk_mcro(E_ACOS, CLAUSE);
		} else {
			prep("Obtain macro acos() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that acos() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("acos() as a macro");
#endif
	finis


#undef	acos

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double acos(double);
		finis
	finis

	done();
}
