#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<time.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.56"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef ctime
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for ctime(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CTIME);
	funct(E_CTIME);

	assertion(2, BASE);
	start
#ifdef ctime
		time_t	*curtime;
		TYP_CHK_ENTITY(ctime(curtime), char *);
#else
		not_implemented("ctime() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	ctime
		if(system((char *)0)) {
			chk_mcro(E_CTIME, CLAUSE);
		} else {
			prep("Obtain macro ctime() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that ctime() macro provided in",
					"<time.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("ctime() as a macro");
#endif
	finis


#undef	ctime

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *ctime(const time_t *);
		finis
	finis

	done();
}
