#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.2.2"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fdopen
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fdopen(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FDOPEN);
	funct(E_FDOPEN);

	assertion(2, BASE);
	start
#ifdef fdopen
		char	type[] = "r";
		TYP_CHK_FUNCT_PTR(fdopen(0, type), FILE);
#else
		not_implemented("fdopen() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fdopen
		if(system((char *)0)) {
			chk_mcro(E_FDOPEN, CLAUSE);
		} else {
			prep("Obtain macro fdopen() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fdopen() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fdopen() as a macro");
#endif
	finis


#undef	fdopen

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern FILE *fdopen(int, const char *);
		finis
	finis

	done();
}
