#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define FILENAME "8.1.11_04"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	FILE	*sfd;
	int		fd;
	char	buffer[_POSIX_PIPE_BUF];

	setup(E_FFLUSH);
	funct(E_FFLUSH);

	assertion(4, BASE);
	start
		time_t	s_time;

		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			setvbuf(sfd, buffer, _IOFBF, _POSIX_PIPE_BUF);
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
		finis

		testing("A call to fflush() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			Zfflush(sfd);
			fd = Zfileno(sfd);
			trf_ck(CHK_CTIME, TRUE, s_time, fd, NO_PATH);
			trf_ck(CHK_MTIME, TRUE, s_time, fd, NO_PATH);
		finis
	finis

	done();
}
