#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef isalnum
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for isalnum(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISALNUM);
	funct(E_ISALNUM);

	assertion(2, BASE);
	start
#ifdef isalnum
		TYP_CHK_FUNCT_INT(isalnum(1),int);
#else
		not_implemented("isalnum() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	isalnum
		if(system((char *)0)) {
			chk_mcro(E_ISALNUM, CLAUSE);
		} else {
			prep("Obtain macro isalnum() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that isalnum() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("isalnum() as a macro");
#endif
	finis


#undef	isalnum

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int isalnum(int);
		finis
	finis

	done();
}
