#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2e"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef isgraph
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for isgraph(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISGRAPH);
	funct(E_ISGRAPH);

	assertion(2, BASE);
	start
#ifdef isgraph
		TYP_CHK_FUNCT_INT(isgraph(1),int);
#else
		not_implemented("isgraph() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	isgraph
		if(system((char *)0)) {
			chk_mcro(E_ISGRAPH, CLAUSE);
		} else {
			prep("Obtain macro isgraph() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that isgraph() macro provided in",
					"<ctype.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("isgraph() as a macro");
#endif
	finis


#undef	isgraph

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int isgraph(int);
		finis
	finis

	done();
}
