#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2j"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef isupper
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for isupper(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISUPPER);
	funct(E_ISUPPER);

	assertion(2, BASE);
	start
#ifdef isupper
		TYP_CHK_FUNCT_INT(isupper(1),int);
#else
		not_implemented("isupper() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	isupper
		if(system((char *)0)) {
			chk_mcro(E_ISUPPER, CLAUSE);
		} else {
			prep("Obtain macro isupper() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that isupper() macro provided in",
					"<ctype.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("isupper() as a macro");
#endif
	finis


#undef	isupper

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int isupper(int);
		finis
	finis

	done();
}
