#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4u"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef ldexp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for ldexp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_LDEXP);
	funct(E_LDEXP);

	assertion(2, BASE);
	start
#ifdef ldexp
		double	value = 1.0;
		TYP_CHK_ENTITY(ldexp(value,2),double);
#else
		not_implemented("ldexp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	ldexp
		if(system((char *)0)) {
			chk_mcro(E_LDEXP, CLAUSE);
		} else {
			prep("Obtain macro ldexp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that ldexp() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("ldexp() as a macro");
#endif
	finis


#undef	ldexp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double ldexp(double,int);
		finis
	finis

	done();
}
