#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.39"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sscanf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for sscanf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SSCANF);
	funct(E_SSCANF);

	assertion(2, BASE);
	start
#ifdef sscanf
		char	c;
		char	buf[2];
		char	msg[] = "Hi";
		TYP_CHK_FUNCT_INT(sscanf(buf, msg, &c), int);
#else
		not_implemented("sscanf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sscanf
		if(system((char *)0)) {
			chk_mcro(E_SSCANF, CLAUSE);
		} else {
			prep("Obtain macro sscanf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sscanf() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sscanf() as a macro");
#endif
	finis


#undef	sscanf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sscanf(const char *, const char *,...);
		finis
	finis

	done();
}
