#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53n"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strlen
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strlen(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRLEN);
	funct(E_STRLEN);

	assertion(2, BASE);
	start
#ifdef strlen
		char	*s1;
		TYP_CHK_FUNCT(strlen(s1), size_t);
#else
		not_implemented("strlen() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strlen
		if(system((char *)0)) {
			chk_mcro(E_STRLEN, CLAUSE);
		} else {
			prep("Obtain macro strlen() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strlen() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strlen() as a macro");
#endif
	finis


#undef	strlen

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern size_t strlen(const char *);
		finis
	finis

	done();
}
