#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strncpy
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strncpy(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRNCPY);
	funct(E_STRNCPY);

	assertion(2, BASE);
	start
#ifdef strncpy
		char	*s1, *s2;
		size_t	n;
		TYP_CHK_FUNCT_PTR(strncpy(s1, s2, n), char);
#else
		not_implemented("strncpy() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strncpy
		if(system((char *)0)) {
			chk_mcro(E_STRNCPY, CLAUSE);
		} else {
			prep("Obtain macro strncpy() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strncpy() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strncpy() as a macro");
#endif
	finis


#undef	strncpy

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *strncpy(char *, const char *, size_t);
		finis
	finis

	done();
}
