#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53k"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strspn
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strspn(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRSPN);
	funct(E_STRSPN);

	assertion(2, BASE);
	start
#ifdef strspn
		char	*s1, *s2;
		TYP_CHK_FUNCT_INT(strspn(s1, s2), size_t);
#else
		not_implemented("strspn() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strspn
		if(system((char *)0)) {
			chk_mcro(E_STRSPN, CLAUSE);
		} else {
			prep("Obtain macro strspn() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strspn() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strspn() as a macro");
#endif
	finis


#undef	strspn

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern size_t strspn(const char *, const char *);
		finis
	finis

	done();
}
