#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.43"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef ungetc
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for ungetc(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_UNGETC);
	funct(E_UNGETC);

	assertion(2, BASE);
	start
#ifdef ungetc
		TYP_CHK_FUNCT_INT(ungetc('C',stdin),int);
#else
		not_implemented("ungetc() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	ungetc
		if(system((char *)0)) {
			chk_mcro(E_UNGETC, CLAUSE);
		} else {
			prep("Obtain macro ungetc() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that ungetc() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("ungetc() as a macro");
#endif
	finis


#undef	ungetc

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int ungetc(int, FILE *);
		finis
	finis

	done();
}
