#include	<pcts.h>

#include	<sv_env.h>

extern	char **environ;

#define	ENV_PARG_1	"PORT1"
#define	ENV_PARG_2	"PORT2"
#define	ENV_PARG_3	"PORT3"
#define	ENV_PARG_4	"PORT4"
#define	ENV_PARG_5	"PORT5"
#define	ENV_DATA_1	"ABCDEFGHIJLKM"
#define	ENV_DATA_2	"NOPQRSTUVWXYZ"
#define	ENV_DATA_3	"abcdefghijlkm"
#define	ENV_DATA_4	"nopqrstuvwxyz"
#define	ENV_DATA_5	"0123456789._-"
#define	ENV_PORTABILITY_1	"PORT1=ABCDEFGHIJLKM"
#define	ENV_PORTABILITY_2	"PORT2=NOPQRSTUVWXYZ"
#define	ENV_PORTABILITY_3	"PORT3=abcdefghijlkm"
#define	ENV_PORTABILITY_4	"PORT4=nopqrstuvwxyz"
#define	ENV_PORTABILITY_5	"PORT5=0123456789._-"


int	main(void)
{
	extern	int	ass_nu;

	setup(E_GETENV);
	funct(E_GETENV);

						/*	Assertion #6, tested in Assertion test #7. */
	assertion(7, BASE);
	start
		prep("Establish an environment for passing via execle().");
		start
			environ[0] = (char *)0;
			put_env(ENV_PORTABILITY_1);
			put_env(ENV_PORTABILITY_2);
			put_env(ENV_PORTABILITY_3);
			put_env(ENV_PORTABILITY_4);
			put_env(ENV_PORTABILITY_5);
		finis

		testing("Environment variable names support the portable.");
		testing("filename character set.");
		start
			char	*p_ret;
	
			exit_on(ERROR);
			p_ret = Zgetenv(ENV_PARG_1);
			if(strcmp(p_ret, ENV_DATA_1))
				error("%s%s\n%s%s\n",
						"Expecting:	",
						ENV_DATA_1,
						"Actual:	",
						p_ret);
	
			if(strcmp(environ[1], ENV_PORTABILITY_2))
				error("%s%s\n%s%s\n",
						"Expecting:	",
						ENV_PORTABILITY_2,
						"Actual:	",
						environ[1]);
	
			if(strcmp(environ[2], ENV_PORTABILITY_3))
				error("%s%s\n%s%s\n",
						"Expecting:	",
						ENV_PORTABILITY_3,
						"Actual:	",
						environ[2]);
	
			if(strcmp(environ[3], ENV_PORTABILITY_4))
				error("%s%s\n%s%s\n",
						"Expecting:	",
						ENV_PORTABILITY_4,
						"Actual:	",
						environ[3]);

			if(strcmp(environ[4], ENV_PORTABILITY_5))
				error("%s%s\n%s%s\n",
						"Expecting:	",
						ENV_PORTABILITY_5,
						"Actual:	",
						environ[4]);
		finis
	finis

	assertion(6, BASE);
	start
		testing("Upper and lower case letters in the environment retain");
		testing("their unique identities.");
		start
					/*	Tested in Assertion #7, if an error occurs
						this process is aborted.
					*/
		finis
	finis
	assertion(8, EXTENDED);

	done();
}
