#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

int	main(void)
{
	setup(E_ISATTY);
	funct(E_ISATTY);

			/* Isatty returns a \"0\" if the file descriptor argument	*/
			/* is not a file descriptor associated with a terminal.		*/
	assertion(5, BASE);
	start
		int		tty_fd;

		break_on(ERROR);
		prep("Open a regular file descriptor.");
		start
			tty_fd = data_open("regular_file", O_RDONLY | O_CREAT, PROT_ALL);
		finis

		testing("Call isatty() using a regular file type file descriptor.");
		start
			expecting(0);
			(void) Zisatty(tty_fd);
		finis

		testing("Call isatty() on a closed file descriptor.");
		start
			(void) Zclose(tty_fd);
			expecting(0);
			(void) Zisatty(tty_fd);
		finis
	finis

			/* isatty() returns \"1\" when the file descriptor argument	*/
			/* is associated with a terminal file.	*/
	assertion(4, BASE);
	start
		pid_t	pid;
		int		fildes;

		GTI_NOT_PROVIDED_EXIT

		exit_on(ERROR);
		FORK
			prep("Open a terminal file.");
			start
				fildes = Zopen(PORT_TTY, O_RDWR | O_NONBLOCK, PERM_CTTY);
			finis

			testing("Call to isatty() using a terminal file descriptor");
			testing("as the argument returns \"1\".");
			start
				expecting(1);
				(void) Zisatty(fildes);
			finis
		KROF
 	finis

	done();
}
