#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.7.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef ttyname
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for ttyname. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TTYNAME);
	funct(E_TTYNAME);

	assertion(2, BASE);
	start
#ifdef ttyname
		int	tty_fd;
		TYP_CHK_FUNCT_PTR(ttyname(tty_fd), char);
#else
		not_implemented("ttyname() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	ttyname
		if(system((char *)0)) {
			chk_mcro(E_TTYNAME, CLAUSE);
		} else {
			prep("Obtain macro ttyname() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that ttyname() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("ttyname() as a macro");
#endif
	finis


#undef	ttyname

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *ttyname(int);
		finis
	finis

	done();
}
