#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<sys/utsname.h>

#include	<sv_env.h>

#define	CLAUSE		"4.4.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef uname
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for uname. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_UNAME);
	funct(E_UNAME);

	assertion(2, BASE);
	start
#ifdef uname
		struct	utsname	s_uts;
		TYP_CHK_FUNCT_INT(uname(&s_uts), int);
#else
		not_implemented("uname() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	uname
		if(system((char *)0)) {
			chk_mcro(E_UNAME, CLAUSE);
		} else {
			prep("Obtain macro uname() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that uname() macro provided in",
					"<sys/utsname.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("uname() as a macro");
#endif
	finis


#undef	uname

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int uname(struct utsname *);
		finis
	finis

	done();
}
