#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zsignal.h>

#include	<sv_env.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

#define	FILENAME	"./3.1.2_39x"
#define	PARAMETERS	a_indx
#include	"exec.h"


int	main(int argc, char *argv[])
{
	int		i;

	SETUP_FOR_EXEC

	assertion(39, BASE);
	start
		FORK
			prep("Establish all signals with action of SIG_DFL.");
			start
				environ[0] = (char *)0;			/* Reset "environ". */
				for(i=0; i<NSIGS; i++) {
					if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP))
						continue;
					SIGNAL(sigs[i].sig, SIG_DFL);
				}
			finis

			EXEC_MODULE(FILENAME)
		KROF
	finis

#undef	FILENAME
#define	FILENAME	"./3.1.2_40x"
	assertion(40, BASE);
	start
		FORK
			prep("Establish most signals with action of SIG_IGN.");
			start
				for(i=0; i<NSIGS; i++) {
					if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP) ||
							(sigs[i].sig == SIGCHLD))
						continue;
					SIGNAL(sigs[i].sig, SIG_IGN);
				}
			finis

			EXEC_MODULE(FILENAME)
		KROF
	finis

#undef	FILENAME
#define	FILENAME	"./3.1.2_41x"
	assertion(41, BASE);
	start
		FORK
			prep("Establish most signals with action to be caught.");
			start
				for(i=0; i<NSIGS; i++) {
					if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP))
						continue;
					SIGNAL(sigs[i].sig, sig_int);
				}
			finis
	
			EXEC_MODULE(FILENAME)
		KROF
	finis

	done();
}
