#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_sigs.h>

int main(void)
{
	struct	sigaction c_sigaction, o_sigaction;
	int		i;

	ass_nu = 39;
	sv_config();					/* Required for next line			  */
	sv_nproc();						/* Maintain proper jounal ID sequence */
	testing("Signal action of signals is SIG_DFL.");
	start
		Zsigemptyset(&c_sigaction.sa_mask);
		c_sigaction.sa_handler = SIG_DFL;
		c_sigaction.sa_flags = 0;
		for(i=0; i<NSIGS; i++) {
			if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP))
				continue;
			Zsigaction(sigs[i].sig, &c_sigaction, &o_sigaction);
			if(o_sigaction.sa_handler != SIG_DFL)
				error("Signal action of signal %s not SIG_DFL.",
						sigs[i].signame);
		}
	finis

	done();
}
