#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

/*	This module has S_ISUID mode set to BIN_UID. */


int main(int argc, char *argv[])
{
	int		e_index;

	e_index = atoi(*argv);
	setup(e_index);
	ass_nu = 44;

	testing("Effective user ID is set to user ID of the file executed.");
	start
		expecting(BIN_UID);
		Zgeteuid();
	finis

	testing("Real user ID remains unchanged.");
	start
		if(getuid() != (uid_t) atoi(*++argv))
			error("%s%d\n%s%d",
					"Expected real user ID of: ",
					(uid_t) atoi(*argv),
					"Actual real user ID is: ",
					getuid());
	finis

	done();
}
