#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

#define	FILENAME	"3.1.1_11"
#define	String		"Woolly bully, woolly bully   \n"
#define	Strlen		(sizeof(String) -1)
#include	<locks.h>


int	main(void)
{
	int		fd;
	pid_t	pid;
	char	buf_out[Strlen];
	struct	flock flock1;

	setup(E_FORK);
	funct(E_FORK);

	exit_on(ERROR);

	assertion(11, BASE);
	start
		char	path[_POSIX_PATH_MAX +1];

		prep("Create a temp file, write to it, and set an exclusive lock");
		prep("on the file.");
		start
			sprintf(path, "%s%s", temp_path(), FILENAME);
	  		fd = Zopen(path, O_CREAT | O_TRUNC | O_RDWR, S_IRWXU);
			expecting(FILE_LENGTH);
			Zwrite(fd, buf_out, FILE_LENGTH);
			SET_LOCK(F_WRLCK, fd, SEEK_SET, ZERO_OFFSET, TOTAL_FILE, &flock1);
		finis

 		prep("File F_WRLCK locked by parent is available for locking.");
 		start
 			GET_LOCK(F_WRLCK, fd, SEEK_SET, ZERO_OFFSET, TOTAL_FILE,
											&flock1);
 			if(flock1.l_type != F_UNLCK)
 				error("%s\n%s%s\n",
 					"Expected no locks on file.",
 					"Actual lock type was set to ",
 					(flock1.l_type == F_WRLCK) ? "F_WRLCK" : 
 						(flock1.l_type == F_RDLCK) ? "F_RDLCK" : "Unknown"); 
 		finis

		FORK
 			testing("Lock previously set by parent is not inherited");
			testing("by the child.");
 			start
 				GET_LOCK(F_WRLCK, fd, SEEK_SET, ZERO_OFFSET, TOTAL_FILE,
												&flock1);
 				if(flock1.l_type != F_WRLCK)
 					error("%s\n%s%s\n",
 						"Expected F_WRLCK on file.",
 						"Actual lock type was set to ",
 						(flock1.l_type == F_UNLCK) ? "F_UNLCK" : 
 							(flock1.l_type == F_RDLCK) ? "F_RDLCK" : "Unknown"); 
 			finis
		KROF
 	finis
 
 	done();
}
