#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.3a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigemptyset
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigemptyset(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGEMPTYSET);
	funct(E_SIGEMPTYSET);

	assertion(2, BASE);
	start
#ifdef sigemptyset
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigemptyset(&set), int);
#else
		not_implemented("sigemptyset() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigemptyset
		if(system((char *)0)) {
			chk_mcro(E_SIGEMPTYSET, CLAUSE);
		} else {
			prep("Obtain macro sigemptyset() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigemptyset() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigemptyset() as a macro");
#endif
	finis


#undef	sigemptyset

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigemptyset(sigset_t *);
		finis
	finis

	done();
}
