#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

int main(void)
{
	pid_t 		pid;
	int		stat_val;
	
	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);

	assertion(30, BASE);
	start
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			testing("Issue a SIGSTOP and test execution is suspended.");
			start
				Zkill(getpid(), SIGSTOP);
				SLEEP(WAIT_FOR_TIME);
				error("Execution not suspended.");
			finis

			done();
		}

		testing("Wait for child process to be stopped.");
		start
			sv_flush();
			SET_ALARM(TIMEOUT)
				Zwaitpid(pid, &stat_val, WUNTRACED);
				while( ! WIFSTOPPED(stat_val) )
					Zwaitpid(pid, &stat_val, WUNTRACED | WNOHANG);
			CLEAR_ALARM
		finis

		cleanup("Terminate child process.");
		start
			Zkill(pid, SIGKILL);
		finis

		WAIT_FOR_PID(pid);
	finis
	
	done();
}
