/* z_tolower.c */

#include <z_pcts.h>
#include <ctype.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef tolower
#endif

static int success(int *val)
{
	return((*val) >= (-1) && (*val) <= 255);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Ttolower = {
	"tolower",
	"a return value of at least (-1) and at most 255",
	"not defined",
	format,
	compare,
	success,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

int  Ztolower(int c)
{
	int ret_val;

	errno = 0;
	ret_val = tolower(c);
	evaluate(&Ttolower, (pointer)&ret_val);
	return(ret_val);
}
