#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>
#include	<sv_env.h>

#define	CLAUSE		"7.2.1a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcgetattr
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcgetattr. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCGETATTR);
	funct(E_TCGETATTR);

	assertion(2, BASE);
	start
#ifdef tcgetattr
		struct	termios *termios_p;
		typ_chk_funct_int(tcgetattr(int, termios_p), int);
#else
		not_implemented("tcgetattr() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcgetattr
		if(system((char *)0)) {
			chk_mcro(E_TCGETATTR, CLAUSE);
		} else {
			prep("Obtain macro tcgetattr() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcgetattr() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcgetattr() as a macro");
#endif
	finis


#undef	tcgetattr

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tcgetattr(int, struct termios *);
		finis
	finis

	done();
}
