#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zpwd.h>

#include	<sv_env.h>

extern	char **environ;

int	main(void)
{
	setup(E_ENV_DESCR);
	funct(E_ENV_DESCR);

				/*	The environment variable HOME is defined by the
					implementation and corresponds to the users initial
					working directory as specified in the user database.
				*/

	assertion(1, BASE);
	start
		char	*home_env;
		struct	passwd *passwd_udb;

		break_on(ERROR);

		prep("Get HOME environment.");
		start
			home_env = Zgetenv("HOME");
		finis

		prep("Get users initial working directory from the user database.");
		start
			passwd_udb = Zgetpwuid(getuid());
		finis

		testing("Compare values.");
		start
			if(strcmp(home_env, passwd_udb->pw_dir))
				error("%s\n%s%s\n%s%s\n",
					"HOME environment variable incorrect.",
					"Expected: ",
					passwd_udb->pw_dir,
					"Actual: ",
					home_env);
		finis
	finis


				/*	The environment variable LOGNAME is defined by the
					implementation and corresponds to the login name
					as specified in the user database.

					NOTE: This assertion is a FIPS 151-2 additional
						  requirement.
				*/

	assertion(2, BASE);
	start
		char	*logname_env;
		struct	passwd *passwd_udb;

		break_on(ERROR);

		prep("Get LOGNAME environment.");
		start
			logname_env = Zgetenv("LOGNAME");
		finis

		prep("Get users initial working directory from the user database.");
		start
			passwd_udb = Zgetpwuid(getuid());
		finis

		testing("Compare values.");
		start
			if(strcmp(logname_env, passwd_udb->pw_name))
				error("%s\n%s%s\n%s%s\n",
					"LOGNAME environment variable incorrect.",
					"Expected: ",
					passwd_udb->pw_name,
					"Actual: ",
					logname_env);
		finis
	finis

	done();
}
