#include	<pcts_ass.h>

#include	<stdlib.h>
#include	<string.h>
#include	<tar.h>

#include	<sv_env.h>

int	main(void)
{
	setup(E_TAR);
	funct(E_TAR);

	assertion(5, BASE);
	start
		testing("When header <tar.h> is included, the symbolic constants");
		testing("TMAGIC, TMAGLEN, TVERSION, and TVERSLEN and corresponding");
		testing("values are defined as ustar, 6, 00, 2 respectively.");
		start
#ifndef	TMAGIC
		 	error("TMAGIC is not defined.");
#else
			if(strncmp(TMAGIC, "ustar", 6))
				error("%s\n%s\n%s\"%6.6s\"\n",
						"TMAGIC value incorrect.",
						"Expected \"ustar\".",
						"Actual ",
						TMAGIC);
#endif

#ifndef	TMAGLEN
		 	error("TMAGLEN is not defined.");
#else
			if(TMAGLEN != 6)
				error("%s\n%s\n%s\"%6.6s\"\n",
						"TMAGLEN value incorrect.",
						"Expected a value of 6.",
						"Actual ",
						TMAGLEN);
#endif

#ifndef	TVERSION
		 	error("TVERSION is not defined.");
#else
			if(strncmp(TVERSION, "00", 2))
				error("%s\n%s\n%s\"%2.2s\"\n",
						"TVERSION value incorrect.",
						"Expected \"00\".",
						"Actual ",
						TVERSION);
#endif

#ifndef	TVERSLEN
		 	error("TVERSLEN is not defined.");
#else
			if(TVERSLEN != 2)
				error("%s\n%s\n%s%d\"\n",
						"TVERSLEN value incorrect.",
						"Expected a value of 2.",
						"Actual value is ",
						TVERSLEN);
#endif
		finis
	finis

	assertion(6, BASE);
	start
		testing("When header <tar.h> is included, the typeflag symbolic");
		testing("constants are defined with proper values.");
		start

#ifndef	REGTYPE
		 	error("REGTYPE is not defined.");
#else
			if(REGTYPE != '0')
				error("%s\n%s\n%s\"%c\"\n",
						"REGTYPE value incorrect.",
						"Expected \"0\".",
						"Actual ",
						REGTYPE);
#endif

#ifndef	AREGTYPE
		 	error("AREGTYPE is not defined.");
#else
			if(AREGTYPE != '\000')
				error("%s\n%s\n%s\"%c\"\n",
						"AREGTYPE value incorrect.",
						"Expected \"\\0\".",
						"Actual ",
						AREGTYPE);
#endif

#ifndef	LNKTYPE
		 	error("LNKTYPE is not defined.");
#else
			if(LNKTYPE != '1')
				error("%s\n%s\n%s\"%c\"\n",
						"LNKTYPE value incorrect.",
						"Expected \"1\".",
						"Actual ",
						LNKTYPE);
#endif

#ifndef	SYMTYPE
		 	error("SYMTYPE is not defined.");
#else
			if(SYMTYPE != '2')
				error("%s\n%s\n%s\"%c\"\n",
						"SYMTYPE value incorrect.",
						"Expected \"2\".",
						"Actual ",
						SYMTYPE);
#endif

#ifndef	CHRTYPE
		 	error("CHRTYPE is not defined.");
#else
			if(CHRTYPE != '3')
				error("%s\n%s\n%s\"%c\"\n",
						"CHRTYPE value incorrect.",
						"Expected \"3\".",
						"Actual ",
						CHRTYPE);
#endif

#ifndef	BLKTYPE
		 	error("BLKTYPE is not defined.");
#else
			if(BLKTYPE != '4')
				error("%s\n%s\n%s\"%c\"\n",
						"BLKTYPE value incorrect.",
						"Expected \"4\".",
						"Actual ",
						BLKTYPE);
#endif

#ifndef	DIRTYPE
		 	error("DIRTYPE is not defined.");
#else
			if(DIRTYPE != '5')
				error("%s\n%s\n%s\"%c\"\n",
						"DIRTYPE value incorrect.",
						"Expected \"5\".",
						"Actual ",
						DIRTYPE);
#endif

#ifndef	FIFOTYPE
		 	error("FIFOTYPE is not defined.");
#else
			if(FIFOTYPE != '6')
				error("%s\n%s\n%s\"%c\"\n",
						"FIFOTYPE value incorrect.",
						"Expected \"6\".",
						"Actual ",
						FIFOTYPE);
#endif

#ifndef	CONTTYPE
		 	error("CONTTYPE is not defined.");
#else
			if(CONTTYPE != '7')
				error("%s\n%s\n%s\"%c\"\n",
						"CONTTYPE value incorrect.",
						"Expected \"7\".",
						"Actual ",
						CONTTYPE);
#endif
		finis
	finis

	assertion(7, BASE);
	start
		testing("When header <tar.h> is included, the mode field symbolic");
		testing("constants are defined with proper values.");
		start

#ifndef	TSUID
		 	error("TSUID is not defined.");
#else
			if(TSUID != 04000)
				error("%s\n%s\n%s\"%d\"\n",
						"TSUID value incorrect.",
						"Expected \"04000\".",
						"Actual ",
						TSUID);
#endif

#ifndef	TSGID
		 	error("TSGID is not defined.");
#else
			if(TSGID != 02000)
				error("%s\n%s\n%s\"%d\"\n",
						"TSGID value incorrect.",
						"Expected \"02000\".",
						"Actual ",
						TSGID);
#endif

#ifndef	TSVTX
		 	error("TSVTX is not defined.");
#else
			if(TSVTX != 01000)
				error("%s\n%s\n%s\"%d\"\n",
						"TSVTX value incorrect.",
						"Expected \"01000\".",
						"Actual ",
						TSVTX);
#endif

#ifndef	TUREAD
		 	error("TUREAD is not defined.");
#else
			if(TUREAD != 00400)
				error("%s\n%s\n%s\"%d\"\n",
						"TUREAD value incorrect.",
						"Expected \"00400\".",
						"Actual ",
						TUREAD);
#endif

#ifndef	TUWRITE
		 	error("TUWRITE is not defined.");
#else
			if(TUWRITE != 00200)
				error("%s\n%s\n%s\"%d\"\n",
						"TUWRITE value incorrect.",
						"Expected \"00200\".",
						"Actual ",
						TUWRITE);
#endif

#ifndef	TUEXEC
		 	error("TUEXEC is not defined.");
#else
			if(TUEXEC != 00100)
				error("%s\n%s\n%s\"%d\"\n",
						"TUEXEC value incorrect.",
						"Expected \"00100\".",
						"Actual ",
						TUEXEC);
#endif

#ifndef	TGREAD
		 	error("TGREAD is not defined.");
#else
			if(TGREAD != 00040)
				error("%s\n%s\n%s\"%d\"\n",
						"TGREAD value incorrect.",
						"Expected \"00040\".",
						"Actual ",
						TGREAD);
#endif

#ifndef	TGWRITE
		 	error("TGWRITE is not defined.");
#else
			if(TGWRITE != 00020)
				error("%s\n%s\n%s\"%d\"\n",
						"TGWRITE value incorrect.",
						"Expected \"00020\".",
						"Actual ",
						TGWRITE);
#endif

#ifndef	TGEXEC
		 	error("TGEXEC is not defined.");
#else
			if(TGEXEC != 00010)
				error("%s\n%s\n%s\"%d\"\n",
						"TGEXEC value incorrect.",
						"Expected \"00010\".",
						"Actual ",
						TGEXEC);
#endif

#ifndef	TOREAD
		 	error("TOREAD is not defined.");
#else
			if(TOREAD != 00004)
				error("%s\n%s\n%s\"%d\"\n",
						"TOREAD value incorrect.",
						"Expected \"00004\".",
						"Actual ",
						TOREAD);
#endif

#ifndef	TOWRITE
		 	error("TOWRITE is not defined.");
#else
			if(TOWRITE != 00002)
				error("%s\n%s\n%s\"%d\"\n",
						"TOWRITE value incorrect.",
						"Expected \"00002\".",
						"Actual ",
						TOWRITE);
#endif

#ifndef	TOEXEC
		 	error("TOEXEC is not defined.");
#else
			if(TOEXEC != 00001)
				error("%s\n%s\n%s\"%d\"\n",
						"TOEXEC value incorrect.",
						"Expected \"00001\".",
						"Actual ",
						TOEXEC);
#endif
		finis
	finis

	done();
}
