#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	path_cwd[_POSIX_PATH_MAX +1];

	setup(E_CHDIR);
	funct(E_CHDIR);

	assertion(19, BASE);
	start
		testing("Successful call to chdir() returns zero.");
		testing("Current working directory matches directory changed to.");
		start	
			char	*path_cmp;

			Zstrcpy(path, temp_path());
			expecting(0);
			Zchdir(path);

			path[Zstrlen(path) -1] = '\000';	/* Delete trailing '/'. */
			Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);
			path_cmp = path_cwd +Zstrlen(path_cwd) -Zstrlen(path) +2;
			if(strcmp(path_cmp, path +2))
				error("%s\n%s.%s\n%s.%s\n",
						"Pathnames do not match.",
						"Expected: ",
						path +2,
						"Actual:   ",
						path_cmp);
		finis
	finis

	done();
}
