#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module set to user ID ROOT.			*/

#define	FILENAME	"5.3.4_37"
#define	DIRNAME		"5.3.4_37.d"

static	char	path_ex[_POSIX_PATH_MAX +1], path_new[_POSIX_PATH_MAX +1];
static	char	*pathm;
void	t_exdev(void);

int main(void)
{
	setup(E_LINK);
	funct(E_LINK);

	assertion(37, BASE);
	start
		if(PCD_LINK_TO_DIRECTORY == TRUE) {
			preparation("Establish paths for linking to a directory.");
			start
				Zstrcpy(path_ex, temp_path());
				Zstrcat(path_ex, DIRNAME);
				Zmkdir(path_ex, PROT_ALL);
	
				Zstrcpy(path_new, temp_path());
				Zstrcat(path_new, FILENAME);
			finis
	
			testing("Appropriate privilege process linking to a directory.");
			start
				Zlink(path_ex, path_new);
			finis

			cleanup("Remove directory links created.");
			start
				Zunlink(path_new);
				Zrmdir(path_ex);
			finis
		} else
			not_implemented("{PCD_LINK_TO_DIRECTORY} of TRUE");
	finis

	assertion(38, NOT_APPLICABLE);

	assertion(40, BASE);
	start
		if(PCD_LINK_FILE_SYSTEM == TRUE)
			t_exdev();
		else
			not_implemented("{PCD_LINK_FILE_SYSTEM} of TRUE");
	finis

	done();
}


void t_exdev(void)
{
	pathm = fs_mount(MOUNT_RW, ROFS_REG_FILE);

	abstract("Ensure mounted file system gets unmounted.");
	start
		break_on(ERROR);
		preparation("Establish paths for linking.");
		start
			Zstrcpy(path_new, pathm);
			Zstrcat(path_new, "/link_exdev");
	
			temp_creat("exdev_ck", PROT_ALL);
			Zstrcpy(path_ex, temp_path());
			Zstrcat(path_ex, "exdev_ck");
		finis
	
		testing("Appropriate privilege process creating a link to a");
		testing("file on a different file system.");
		testing("Path name is \"%s\".", path_new);
		start
			if(PCD_LINK_FILE_SYSTEM == FALSE)
				expecting(EXDEV);
			Zlink(path_ex, path_new);
		finis
	finis
	
	(void) fs_umount(ROFS_REG_FILE);
}
