#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module has S_ISUID set to ROOT. */

#define	DIRNAME		"5.5.1_9.d"
#define	DIRNAME_NEW	"5.5.1_9.dir"


int main(void)
{
	char	path_cwd[_POSIX_PATH_MAX +1], path_ref[_POSIX_PATH_MAX +1];

	setup(E_UNLINK);
	funct(E_UNLINK);

	assertion(9, BASE);
	start
		if(PCD_LINK_TO_DIRECTORY == TRUE) {
			prep("Change current working directory to \"../tmp/%s.d\".",
									element[(int) E_UNLINK].e_name);
			prep("Create known directory in working directory.");
			start
				exit_on(ERROR);
				Zstrcpy(path_cwd, temp_path());
				path_cwd[strlen(path_cwd) -1] = '\000';/* delete trailing '/' */
				Zchdir(path_cwd);
				Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);
				Zmkdir(DIRNAME, S_IRWXU);
										/*
												   Working_Directory
												          |
												          |
											            DIRNAME
										*/
			finis

			testing("Existing argument points to the string \"F1/\" and");
			testing("F1 is a directory.");
			start
				Zlink(DIRNAME, DIRNAME_NEW);
				Zaccess(DIRNAME_NEW, F_OK);

				sprintf(path_ref, "%s/", DIRNAME_NEW);
				Zunlink(path_ref);
				expecting(ENOENT);
				Zaccess(DIRNAME_NEW, F_OK);
			finis
		}
		else
			not_implemented("{PCD_LINK_TO_DIRECTORY} of TRUE");
	finis

	assertion(10, BASE);
	start
		if(PCD_LINK_TO_DIRECTORY == TRUE) {
			testing("Existing argument points to the string \"F1//\" and");
			testing("F1 is a directory.");
			start
				Zlink(DIRNAME, DIRNAME_NEW);
				Zaccess(DIRNAME_NEW, F_OK);

				sprintf(path_ref, "%s//", DIRNAME_NEW);
				Zunlink(path_ref);
				expecting(ENOENT);
				Zaccess(DIRNAME_NEW, F_OK);
			finis
		}
		else
			not_implemented("{PCD_LINK_TO_DIRECTORY} of TRUE");
	finis

	if(PCD_LINK_TO_DIRECTORY == TRUE) {
		cleanup("Remove test directory.");
		start
			Zrmdir(DIRNAME);
		finis
	}

	done();
}
