#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module has user ID set to ROOT. */

#define	DIRNAME		"5.5.1_23.d"
#define	DIRNAME2	"5.5.1_23_d2"


int main(void)
{
	struct	stat st_buf, st_buf2;
	char	path[_POSIX_PATH_MAX +1], path2[_POSIX_PATH_MAX +1];

	setup(E_UNLINK);
	funct(E_UNLINK);

	assertion(23, EXTENDED_TESTED);
	start
		if((PCD_LINK_TO_DIRECTORY == TRUE) && (PCD_UNLINK_DIRECTORY == TRUE)) {
			preparation("Establish paths for unlinking directory testing.");
			start
				Zstrcpy(path, temp_path());
				Zstrcat(path, DIRNAME);
				Zmkdir(path, PROT_ALL);
				Zstat(path, &st_buf);
	
				Zstrcpy(path2, temp_path());
				Zstrcat(path2, DIRNAME2);
				Zlink(path, path2);
			finis
	
			testing("Appropriate privilege process unlinking a directory.");
			start
				expecting(0);
				Zunlink(path2);

				expecting(ENOENT);
				Zaccess(path2, F_OK);

				Zstat(path, &st_buf2);
				if(st_buf.st_nlink != st_buf2.st_nlink)
					error("%s%lu\n%s%lu",
						"Expected link count of ",
						(unsigned long) st_buf.st_nlink,
						"Actual link count is ",
						(unsigned long) st_buf2.st_nlink);
			finis

		} else
			not_implemented("linking to a directory");
	finis

	done();
}
