#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<utime.h>
#include	<sv_env.h>

#define	CLAUSE		"5.6.6"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef utime
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for utime(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_UTIME);
	funct(E_UTIME);

	assertion(2, BASE);
	start
#ifdef utime
		struct	utimbuf	*times;
		TYP_CHK_FUNCT_INT(utime("ABC", times), int);
#else
		not_implemented("utime() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	utime
		if(system((char *)0)) {
			chk_mcro(E_UTIME, CLAUSE);
		} else {
			prep("Obtain macro utime() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that utime() macro provided in",
					"<utime.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("utime() as a macro");
#endif
	finis


#undef	utime

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int utime(const char *, const struct utimbuf *);
		finis
	finis

	done();
}
