#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"6.2.1b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef dup2
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for dup2. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_DUP2);
	funct(E_DUP2);

	assertion(2, BASE);
	start
#ifdef dup2
		int	fd, fd2;
		TYP_CHK_FUNCT_INT(dup2(fd, fd2), int);
#else
		not_implemented("dup2() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	dup2
		if(system((char *)0)) {
			chk_mcro(E_DUP2, CLAUSE);
		} else {
			prep("Obtain macro dup2() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that dup2() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("dup2() as a macro");
#endif
	finis


#undef	dup2

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int dup2(int, int);
		finis
	finis

	done();
}
