#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int main(void)
{
	int 	fildes[2];

	setup(E_PIPE);
	funct(E_PIPE);

	assertion(12, BASE);
	start
		int		open_max, topen_max, i;
		char	path[_POSIX_PATH_MAX +1];

		break_on(ERROR);

		open_max = g_open_max();	/* Get value for {OPEN_MAX} */
									/* Get testable value for {OPEN_MAX} */
		topen_max = (open_max <= PCTS_OPEN_MAX) ? open_max : PCTS_OPEN_MAX;

		prep("Close all (%d) file descriptors except 0, 1 and 2.", topen_max);
		start
			for(i=3; i<topen_max; i++)
				close(i);
		finis

		prep("Initialize a path name.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "fill_up");
		finis

		if(open_max <= PCTS_OPEN_MAX) {
			prep("{OPEN_MAX} equal to {PCTS_OPEN_MAX}.");
			prep("Consume all available less one file descriptors.");
			start
				for(i=3; i<(open_max -1); i++)
					(void) Zcreat(path, PROT_ALL);
			finis

			testing("Call pipe().");
			start
				expecting(-1);
				expecting(EMFILE);
				(void) Zpipe(fildes);
			finis
		}
		else {
			prep("Testing for {PCTS_OPEN_MAX} < {OPEN_MAX}.");
			prep("Consume PCTS_OPEN_MAX -2 file descriptors."); 
			start
				for(i=3; i<(topen_max -2); i++)
					(void) Zcreat(path, PROT_ALL);
			finis

			testing("pipe() on the {PCTS_OPEN_MAX} -2 file descriptor.");
			start
				expecting(SUCCESS);
				(void) Zpipe(fildes);
			finis
		}

		cleanup("Close all file descriptors except 0, 1 and 2.");
		start
			for(i=3; i<topen_max; i++)
				(void) close(i);
		finis
	finis

	assertion(13, EXTENDED);

	done();
}
