#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4o"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fabs
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fabs(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FABS);
	funct(E_FABS);

	assertion(2, BASE);
	start
#ifdef fabs
		double	value;
		TYP_CHK_ENTITY(fabs(value),double);
#else
		not_implemented("fabs() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fabs
		if(system((char *)0)) {
			chk_mcro(E_FABS, CLAUSE);
		} else {
			prep("Obtain macro fabs() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fabs() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fabs() as a macro");
#endif
	finis


#undef	fabs

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double fabs(double);
		finis
	finis

	done();
}
