#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4p"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef floor
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for floor(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FLOOR);
	funct(E_FLOOR);

	assertion(2, BASE);
	start
#ifdef floor
		double	value;
		TYP_CHK_ENTITY(floor(value),double);
#else
		not_implemented("floor() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	floor
		if(system((char *)0)) {
			chk_mcro(E_FLOOR, CLAUSE);
		} else {
			prep("Obtain macro floor() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that floor() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("floor() as a macro");
#endif
	finis


#undef	floor

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double floor(double);
		finis
	finis

	done();
}
