#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4t"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef frexp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for frexp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FREXP);
	funct(E_FREXP);

	assertion(2, BASE);
	start
#ifdef frexp
		double		value;
		int			*value2;
		TYP_CHK_FUNCT(frexp(value,value2),double);
#else
		not_implemented("frexp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	frexp
		if(system((char *)0)) {
			chk_mcro(E_FREXP, CLAUSE);
		} else {
			prep("Obtain macro frexp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that frexp() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("frexp() as a macro");
#endif
	finis


#undef	frexp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double frexp(double,int *);
		finis
	finis

	done();
}
