#include	<pcts.h>

#include	<Ztime.h>
#include	<locale.h>
#include	<sv_env.h>

#define	SECS_PER_MINUTE		60
#define	SECS_PER_HOUR		(SECS_PER_MINUTE * 60)
#define	SECS_PER_DAY		(SECS_PER_HOUR * 24)
#define	DAYS_PER_YEAR		365
#define	SECS_PER_YEAR		(SECS_PER_DAY * DAYS_PER_YEAR)


int	main(void)
{
	time_t	timer;
	struct	tm *tm;
							/* Christmas day, 1992, 12:30:10 */
	int		year	= 1992;
	int		yday	= 359;
	int		hour	= 12;
	int		min		= 30;
	int		sec		= 10;

	int		mday	= 25;
	int		mon		= 11;
	int		wday	= 5;
	int		isdst	= 0;

	setup(E_ASCTIME);
	funct(E_ASCTIME);

	assertion(4, BASE);
	start
		testing("Call to gmtime() returns proper results.");
		start
						/* Compute timer value for known inputs. */
			timer = (time_t) (sec +min*SECS_PER_MINUTE +hour*SECS_PER_HOUR
				 			+yday*SECS_PER_DAY +(year -1970)*SECS_PER_YEAR
				 			+((year -1969)/4)*SECS_PER_DAY);
						/* Compare with results from gmtime(). */
			tm = gmtime(&timer);
			if(tm->tm_sec != sec)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_sec.",
						sec,
						tm->tm_sec);
			if(tm->tm_min != min)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_min.",
						min,
						tm->tm_min);
			if(tm->tm_hour != hour)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_hour.",
						hour,
						tm->tm_hour);
			if(tm->tm_mday != mday)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_mday.",
						mday,
						tm->tm_mday);
			if(tm->tm_mon != mon)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_mon.",
						mon,
						tm->tm_mon);
			if(tm->tm_year != year -1900)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_year.",
						year -1900,
						tm->tm_year);
			if(tm->tm_wday != wday)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_wday.",
						wday,
						tm->tm_wday);
			if(tm->tm_yday != yday)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_yday.",
						yday,
						tm->tm_yday);
			if(tm->tm_isdst != isdst)
				error("%s\nExpected: %d\nActual: %d",
						"Incorrect value reported for tm_isdst.",
						isdst,
						tm->tm_isdst);
		finis
	finis

	done();
}
