#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef isdigit
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for isdigit(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISDIGIT);
	funct(E_ISDIGIT);

	assertion(2, BASE);
	start
#ifdef isdigit
		TYP_CHK_FUNCT_INT(isdigit(1),int);
#else
		not_implemented("isdigit() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	isdigit
		if(system((char *)0)) {
			chk_mcro(E_ISDIGIT, CLAUSE);
		} else {
			prep("Obtain macro isdigit() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that isdigit() macro provided in",
					"<ctype.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("isdigit() as a macro");
#endif
	finis


#undef	isdigit

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int isdigit(int);
		finis
	finis

	done();
}
