#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.32"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef putchar
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for putchar(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_PUTCHAR);
	funct(E_PUTCHAR);

	assertion(2, BASE);
	start
#ifdef putchar
		TYP_CHK_FUNCT_INT(putchar('c'), int);
#else
		not_implemented("putchar() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	putchar
		if(system((char *)0)) {
			chk_mcro(E_PUTCHAR, CLAUSE);
		} else {
			prep("Obtain macro putchar() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that putchar() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("putchar() as a macro");
#endif
	finis


#undef	putchar

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int putchar(int);
		finis
	finis

	done();
}
