#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<setjmp.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.5"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef setjmp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for setjmp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SETJMP);
	funct(E_SETJMP);

	assertion(2, BASE);
	start
#ifdef setjmp
		jmp_buf	buf;
		testing("Assign of setjmp(buf) to variable of type int.");
		start
			int	var;
			if(0)
				var = setjmp(buf);
		finis

		testing("Compare setjmp() to integral constant.");
		start
								/*	setjmp() in a relational expression can
									only use integral constant expressions.
									ANSI C requirement.
								*/
			if(0)
				if(0 == setjmp(buf));
		finis

								/*	No test performed on negation of setjmp().
		   							Negation of setjmp() is unacceptable syntax
									for ANSI C.
								*/
#else
		not_implemented("setjmp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	setjmp
		if(system((char *)0)) {
			chk_mcro(E_SETJMP, CLAUSE);
		} else {
			prep("Obtain macro setjmp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that setjmp() macro provided in",
					"<setjmp.h> satisfies requirements of this assertion.");
			finis
		}
#else
		not_implemented("setjmp() as a macro");
#endif
	finis


	assertion(1, BASE);
	start
#ifdef	setjmp
		yes_implemented("setjmp() as a macro");
#else
		jmp_buf	buf;
		testing("Assign of setjmp(buf) to variable of type int.");
		start
			int	var;
			if(0)
				var = setjmp(buf);
		finis

		testing("Compare setjmp() to integral constant.");
		start
			if(0)
				if(0 == setjmp(buf));
		finis
#endif
	finis

	done();
}
