#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<locale.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef setlocale
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for setlocale(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SETLOCALE);
	funct(E_SETLOCALE);

	assertion(2, BASE);
	start
#ifdef setlocale
		char	locale[] = "C";
		TYP_CHK_FUNCT_PTR(setlocale(LC_ALL, locale), char);
#else
		not_implemented("setlocale() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	setlocale
		if(system((char *)0)) {
			chk_mcro(E_SETLOCALE, CLAUSE);
		} else {
			prep("Obtain macro setlocale() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that setlocale() macro provided in",
					"<locale.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("setlocale() as a macro");
#endif
	finis


#undef	setlocale

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *setlocale(int, const char *);
		finis
	finis

	done();
}
