#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4h"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sinh
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for sinh(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SINH);
	funct(E_SINH);

	assertion(2, BASE);
	start
#ifdef sinh
		double	value;
		TYP_CHK_ENTITY(sinh(value),double);
#else
		not_implemented("sinh() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sinh
		if(system((char *)0)) {
			chk_mcro(E_SINH, CLAUSE);
		} else {
			prep("Obtain macro sinh() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sinh() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sinh() as a macro");
#endif
	finis


#undef	sinh

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double sinh(double);
		finis
	finis

	done();
}
