#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.2.1c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getgid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getgid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETGID);
	funct(E_GETGID);

	assertion(2, BASE);
	start
#ifdef getgid
		TYP_CHK_FUNCT_INT(getgid(),gid_t);
#else
		not_implemented("getgid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getgid
		if(system((char *)0)) {
			chk_mcro(E_GETGID, CLAUSE);
		} else {
			prep("Obtain macro getgid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getgid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getgid() as a macro");
#endif
	finis


#undef	getgid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern gid_t getgid(void);
		finis
	finis

	done();
}
