#include	<pcts.h>

#include	<Zunistd.h>
#include	<sv_env.h>

/* This module has the S_ISUID mode set to BIN_UID.  */

int	main(void)
{
	char	*name;

	setup(E_GETLOGIN);
	funct(E_GETLOGIN);

	assertion(4, BASE);
	start
			/* Successful completion, getlogin returns a pointer to the
			   user's login name associated  by the login activity with
			   the control terminal both when the real user ID is equal to
			   the effective user ID and when it is not equal to the
			   effective user ID.
		   */
		testing("Call getlogin() when the real user ID is not equal to");
		testing("the effective user ID.");
		start
			name = Zgetlogin();
			if(strcmp(LOGNAME, name))
				error("%s\n%s%s.\n%s\"%s\".",
					"Incorrect return value from getlogin.",
					"Expected name: ",
					LOGNAME,
					"Actual name: ",
					name);
		finis

		prep("Set process's effective user ID to the real user ID.");
		start
			Zsetuid(UID);
		finis

		testing("Call getlogin when the real user ID is equal to");
		testing("the effective user ID.");
		start
			name = Zgetlogin();
			if(strcmp(LOGNAME, name))
				error("%s\n%s%s.\n%s\"%s\".",
					"Incorrect return value from getlogin.",
					"Expected name: ",
					LOGNAME,
					"Actual name: ",
					name);
		finis
	finis

	assertion(5, EXTENDED);

	done();
}
