#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.2.1a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getuid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getuid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETUID);
	funct(E_GETUID);

	assertion(2, BASE);
	start
#ifdef getuid
		TYP_CHK_FUNCT_INT(getuid(),uid_t);
#else
		not_implemented("getuid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getuid
		if(system((char *)0)) {
			chk_mcro(E_GETUID, CLAUSE);
		} else {
			prep("Obtain macro getuid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getuid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getuid() as a macro");
#endif
	finis


#undef	getuid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern uid_t getuid(void);
		finis
	finis

	done();
}
