#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.7.2b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef isatty
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for isatty. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISATTY);
	funct(E_ISATTY);

	assertion(2, BASE);
	start
#ifdef isatty
		int	tty_fd;
		TYP_CHK_FUNCT_INT(isatty(tty_fd), int);
#else
		not_implemented("isatty() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	isatty
		if(system((char *)0)) {
			chk_mcro(E_ISATTY, CLAUSE);
		} else {
			prep("Obtain macro isatty() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that isatty() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("isatty() as a macro");
#endif
	finis


#undef	isatty

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int isatty(int);
		finis
	finis

	done();
}
