extern	char	**environ;
static	int		e_index;

#define	ID_LENGTH	20
static	char	a_indx[ID_LENGTH];
static	char	a_param1[ID_LENGTH], a_param2[ID_LENGTH], a_param3[ID_LENGTH];
static	pid_t	pid;

static	char	*args[] =	{
							PARAMETERS,
							(char *)0,
						};

#define	SETUP_FOR_EXEC { \
			e_index = atoi(*++argv); \
			strcpy(a_indx, *argv); \
			setup(e_index); \
			funct(e_index); \
		}

#define	EXEC_MODULE(filename) { \
				prep("Exec module to test assertions."); \
				start \
				  switch(e_index) { \
					case E_EXECL: \
						Zexecl(filename, PARAMETERS, (char *)0); \
						break; \
					case E_EXECLE: \
						Zexecle(filename, PARAMETERS, (char *)0, environ); \
						break; \
					case E_EXECV: \
		    			Zexecv(filename, args); \
						break; \
					case E_EXECVE: \
		    			Zexecve(filename, args, environ); \
						break; \
					case E_EXECLP: \
						Zexeclp(filename, PARAMETERS, (char *)0); \
						break; \
					case E_EXECVP: \
		    			Zexecvp(filename, args); \
						break; \
					default: \
						error("Bad indx \"%d\" passed to exec24().",e_index); \
				  } \
				finis \
		}
