#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.3b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigfillset
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigfillset(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGFILLSET);
	funct(E_SIGFILLSET);

	assertion(2, BASE);
	start
#ifdef sigfillset
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigfillset(&set), int);
#else
		not_implemented("sigfillset() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigfillset
		if(system((char *)0)) {
			chk_mcro(E_SIGFILLSET, CLAUSE);
		} else {
			prep("Obtain macro sigfillset() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigfillset() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigfillset() as a macro");
#endif
	finis


#undef	sigfillset

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigfillset(sigset_t *);
		finis
	finis

	done();
}
