#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.7"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigsuspend
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigsuspend(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGSUSPEND);
	funct(E_SIGSUSPEND);

	assertion(2, BASE);
	start
#ifdef sigsuspend
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigsuspend(&set), int);
#else
		not_implemented("sigsuspend() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigsuspend
		if(system((char *)0)) {
			chk_mcro(E_SIGSUSPEND, CLAUSE);
		} else {
			prep("Obtain macro sigsuspend() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigsuspend() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigsuspend() as a macro");
#endif
	finis


#undef	sigsuspend

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigsuspend(const sigset_t *);
		finis
	finis

	done();
}
