#include	<pcts.h>

#include	<Zfcntl.h>

#include	<sv_env.h>

/*
** data_open
**
**	Path manipulation procedure.
**	This procedure opens a file in the data directory
**
**	Assumes that the data directory is one level up from the current one
**
** Arguments
**	in_path		string indicating path offset from the base directory
**	oflag, mode	passed on the the open call
**
*/

int data_open(char *in_path, int oflag, mode_t mode)
{
	char	temp_buf[_POSIX_PATH_MAX +1];

	(void) Zstrcpy(temp_buf, sv_data_path());
	(void) Zstrcat(temp_buf, in_path);
	return(Zopen(temp_buf, oflag, mode));
}
