#include	<pcts.h>

#include	<Zfcntl.h>

#include	<sv_env.h>

/*
** temp_creat
**
**	Path manipulation procedure.
**	This procedure create a file in the temp directory
**
**	Assumes that the temp directory is one level up from the current one
**
** Arguments
**	in_path		string indicating path offset from the base directory
**	mode	passed on the the creat call
**
*/

int temp_creat(char *in_path, mode_t mode)
{
	char	temp_buf[_POSIX_PATH_MAX +1];

	(void) Zstrcpy(temp_buf, sv_temp_path());
	(void) Zstrcat(temp_buf, in_path);
	return(Zcreat(temp_buf, mode));
}
