/* z_atoi.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef atoi
#endif

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tatoi = {
	"atoi",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

int  Zatoi(char *str)
{
	int ret_val;

	errno = 0;
	ret_val = atoi(str);
	evaluate(&Tatoi, (pointer)&ret_val);
	return(ret_val);
}
