/* z_geteuid.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	geteuid
#endif

static char *format(uid_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%lu", (unsigned long) *val);
	return(buf);
}

static int compare(uid_t *a, uid_t *b)
{
	return(*a == *b);
}

extern uid_t *sv_guid_t(void);

static struct ftable Tgeteuid = {
	"geteuid",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_guid_t,
	0,
};

uid_t  Zgeteuid(void)
{
	uid_t ret_val;

	errno = 0;
	ret_val = geteuid();
	evaluate(&Tgeteuid, (pointer)&ret_val);
	return(ret_val);
}
