/* z_strncmp.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef strncmp
#endif

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tstrncmp = {
	"strncmp",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

int  Zstrncmp(const char *s1, const char *s2, size_t n)
{
	int ret_val;

	errno = 0;
	ret_val = strncmp(s1, s2, n);
	evaluate(&Tstrncmp, (pointer)&ret_val);
	return(ret_val);
}
